# v8-runtime-functions [![build status](https://secure.travis-ci.org/thlorenz/v8-runtime-functions.png)](http://travis-ci.org/thlorenz/v8-runtime-functions)

Exposes and documents v8 runtime functions.

## Status

**MAD SCIENCE**

## Installation

    npm install v8-runtime-functions

<!-- START doctoc generated TOC please keep comment here to allow auto update -->
<!-- DON'T EDIT THIS SECTION, INSTEAD RE-RUN doctoc TO UPDATE -->
**Table of Contents**  *generated with [DocToc](http://doctoc.herokuapp.com/)*

- [API](#api)
    - [_Arguments(arg1)](#_argumentsarg1)
    - [_ArgumentsLength()](#_argumentslength)
    - [_ClassOf(arg1)](#_classofarg1)
    - [_FastAsciiArrayJoin(arg1, arg2)](#_fastasciiarrayjoinarg1-arg2)
    - [_GeneratorThrow(arg1, arg2)](#_generatorthrowarg1-arg2)
    - [_GetCachedArrayIndex(arg1)](#_getcachedarrayindexarg1)
    - [_GetFromCache(arg1, arg2)](#_getfromcachearg1-arg2)
    - [_HasCachedArrayIndex(arg1)](#_hascachedarrayindexarg1)
    - [_IsArray(arg1)](#_isarrayarg1)
    - [_IsConstructCall()](#_isconstructcall)
    - [_IsFunction(arg1)](#_isfunctionarg1)
    - [_IsNonNegativeSmi(arg1)](#_isnonnegativesmiarg1)
    - [_IsObject(arg1)](#_isobjectarg1)
    - [_IsRegExp(arg1)](#_isregexparg1)
    - [_IsSmi(arg1)](#_issmiarg1)
    - [_IsSpecObject(arg1)](#_isspecobjectarg1)
    - [_IsStringWrapperSafeForDefaultValueOf(arg1)](#_isstringwrappersafefordefaultvalueofarg1)
    - [_IsUndetectableObject(arg1)](#_isundetectableobjectarg1)
    - [_MathPow(arg1, arg2)](#_mathpowarg1-arg2)
    - [_NumberToString(arg1)](#_numbertostringarg1)
    - [_ObjectEquals(arg1, arg2)](#_objectequalsarg1-arg2)
    - [_RegExpConstructResult(arg1, arg2, arg3)](#_regexpconstructresultarg1-arg2-arg3)
    - [_RegExpExec(arg1, arg2, arg3, arg4)](#_regexpexecarg1-arg2-arg3-arg4)
    - [_SetValueOf(arg1, arg2)](#_setvalueofarg1-arg2)
    - [_StringAdd(arg1, arg2)](#_stringaddarg1-arg2)
    - [_StringCharAt(arg1, arg2)](#_stringcharatarg1-arg2)
    - [_StringCharCodeAt(arg1, arg2)](#_stringcharcodeatarg1-arg2)
    - [_StringCharFromCode(arg1)](#_stringcharfromcodearg1)
    - [_StringCompare(arg1, arg2)](#_stringcomparearg1-arg2)
    - [_SubString(arg1, arg2, arg3)](#_substringarg1-arg2-arg3)
    - [_ValueOf(arg1)](#_valueofarg1)
    - [Abort(arg1)](#abortarg1)
    - [AbortJS(arg1)](#abortjsarg1)
    - [Apply(arg1, arg2, arg3, arg4, arg5)](#applyarg1-arg2-arg3-arg4-arg5)
    - [ArrayBufferGetByteLength(arg1)](#arraybuffergetbytelengtharg1)
    - [ArrayBufferInitialize(arg1, arg2)](#arraybufferinitializearg1-arg2)
    - [ArrayBufferIsView(arg1)](#arraybufferisviewarg1)
    - [ArrayBufferNeuter(arg1)](#arraybufferneuterarg1)
    - [ArrayBufferSliceImpl(arg1, arg2, arg3)](#arraybuffersliceimplarg1-arg2-arg3)
    - [ArrayBufferViewGetByteLength(arg1)](#arraybufferviewgetbytelengtharg1)
    - [ArrayBufferViewGetByteOffset(arg1)](#arraybufferviewgetbyteoffsetarg1)
    - [ArrayConcat(arg1)](#arrayconcatarg1)
    - [BasicJSONStringify(arg1)](#basicjsonstringifyarg1)
    - [BoundFunctionGetBindings(arg1)](#boundfunctiongetbindingsarg1)
    - [Break()](#break)
    - [ChangeBreakOnException(arg1, arg2)](#changebreakonexceptionarg1-arg2)
    - [CharFromCode(arg1)](#charfromcodearg1)
    - [CheckExecutionState(arg1)](#checkexecutionstatearg1)
    - [CheckIsBootstrapping()](#checkisbootstrapping)
    - [ClearBreakPoint(arg1)](#clearbreakpointarg1)
    - [ClearFunctionTypeFeedback(arg1)](#clearfunctiontypefeedbackarg1)
    - [ClearStepping()](#clearstepping)
    - [CollectGarbage(arg1)](#collectgarbagearg1)
    - [CollectStackTrace(arg1, arg2, arg3)](#collectstacktracearg1-arg2-arg3)
    - [CompileForOnStackReplacement(arg1)](#compileforonstackreplacementarg1)
    - [CompileString(arg1, arg2)](#compilestringarg1-arg2)
    - [ConstructDouble(arg1, arg2)](#constructdoublearg1-arg2)
    - [CreateApiFunction(arg1, arg2)](#createapifunctionarg1-arg2)
    - [CreateGlobalPrivateSymbol(arg1)](#createglobalprivatesymbolarg1)
    - [CreateJSFunctionProxy(arg1, arg2, arg3, arg4)](#createjsfunctionproxyarg1-arg2-arg3-arg4)
    - [CreateJSProxy(arg1, arg2)](#createjsproxyarg1-arg2)
    - [CreatePrivateSymbol(arg1)](#createprivatesymbolarg1)
    - [CreateSymbol(arg1)](#createsymbolarg1)
    - [DataViewGetBuffer(arg1)](#dataviewgetbufferarg1)
    - [DataViewGetFloat32(arg1, arg2, arg3)](#dataviewgetfloat32arg1-arg2-arg3)
    - [DataViewGetFloat64(arg1, arg2, arg3)](#dataviewgetfloat64arg1-arg2-arg3)
    - [DataViewGetInt8(arg1, arg2, arg3)](#dataviewgetint8arg1-arg2-arg3)
    - [DataViewGetInt16(arg1, arg2, arg3)](#dataviewgetint16arg1-arg2-arg3)
    - [DataViewGetInt32(arg1, arg2, arg3)](#dataviewgetint32arg1-arg2-arg3)
    - [DataViewGetUint8(arg1, arg2, arg3)](#dataviewgetuint8arg1-arg2-arg3)
    - [DataViewGetUint16(arg1, arg2, arg3)](#dataviewgetuint16arg1-arg2-arg3)
    - [DataViewGetUint32(arg1, arg2, arg3)](#dataviewgetuint32arg1-arg2-arg3)
    - [DataViewInitialize(arg1, arg2, arg3, arg4)](#dataviewinitializearg1-arg2-arg3-arg4)
    - [DataViewSetFloat32(arg1, arg2, arg3, arg4)](#dataviewsetfloat32arg1-arg2-arg3-arg4)
    - [DataViewSetFloat64(arg1, arg2, arg3, arg4)](#dataviewsetfloat64arg1-arg2-arg3-arg4)
    - [DataViewSetInt8(arg1, arg2, arg3, arg4)](#dataviewsetint8arg1-arg2-arg3-arg4)
    - [DataViewSetInt16(arg1, arg2, arg3, arg4)](#dataviewsetint16arg1-arg2-arg3-arg4)
    - [DataViewSetInt32(arg1, arg2, arg3, arg4)](#dataviewsetint32arg1-arg2-arg3-arg4)
    - [DataViewSetUint8(arg1, arg2, arg3, arg4)](#dataviewsetuint8arg1-arg2-arg3-arg4)
    - [DataViewSetUint16(arg1, arg2, arg3, arg4)](#dataviewsetuint16arg1-arg2-arg3-arg4)
    - [DataViewSetUint32(arg1, arg2, arg3, arg4)](#dataviewsetuint32arg1-arg2-arg3-arg4)
    - [DateCacheVersion()](#datecacheversion)
    - [DateCurrentTime()](#datecurrenttime)
    - [DateLocalTimezone(arg1)](#datelocaltimezonearg1)
    - [DateMakeDay(arg1, arg2)](#datemakedayarg1-arg2)
    - [DateParseString(arg1, arg2)](#dateparsestringarg1-arg2)
    - [DateSetValue(arg1, arg2, arg3)](#datesetvaluearg1-arg2-arg3)
    - [DateToUTC(arg1)](#datetoutcarg1)
    - [DebugBreak()](#debugbreak)
    - [DebugBreakInOptimizedCode()](#debugbreakinoptimizedcode)
    - [DebugCallbackSupportsStepping(arg1)](#debugcallbacksupportssteppingarg1)
    - [DebugConstructedBy(arg1, arg2)](#debugconstructedbyarg1-arg2)
    - [DebugDisassembleConstructor(arg1)](#debugdisassembleconstructorarg1)
    - [DebugDisassembleFunction(arg1)](#debugdisassemblefunctionarg1)
    - [DebugEvaluate(arg1, arg2, arg3, arg4, arg5, arg6)](#debugevaluatearg1-arg2-arg3-arg4-arg5-arg6)
    - [DebugEvaluateGlobal(arg1, arg2, arg3, arg4)](#debugevaluateglobalarg1-arg2-arg3-arg4)
    - [DebugGetLoadedScripts()](#debuggetloadedscripts)
    - [DebugGetProperty(arg1, arg2)](#debuggetpropertyarg1-arg2)
    - [DebugGetPropertyDetails(arg1, arg2)](#debuggetpropertydetailsarg1-arg2)
    - [DebugGetPrototype(arg1)](#debuggetprototypearg1)
    - [DebugIndexedInterceptorElementValue(arg1, arg2)](#debugindexedinterceptorelementvaluearg1-arg2)
    - [DebugNamedInterceptorPropertyValue(arg1, arg2)](#debugnamedinterceptorpropertyvaluearg1-arg2)
    - [DebugPrepareStepInIfStepping(arg1)](#debugpreparestepinifsteppingarg1)
    - [DebugPrint(arg1)](#debugprintarg1)
    - [DebugPrintScopes()](#debugprintscopes)
    - [DebugPromiseHandleEpilogue()](#debugpromisehandleepilogue)
    - [DebugPromiseHandlePrologue(arg1)](#debugpromisehandleprologuearg1)
    - [DebugPropertyAttributesFromDetails(arg1)](#debugpropertyattributesfromdetailsarg1)
    - [DebugPropertyIndexFromDetails(arg1)](#debugpropertyindexfromdetailsarg1)
    - [DebugPropertyTypeFromDetails(arg1)](#debugpropertytypefromdetailsarg1)
    - [DebugReferencedBy(arg1, arg2, arg3)](#debugreferencedbyarg1-arg2-arg3)
    - [DebugSetScriptSource(arg1, arg2)](#debugsetscriptsourcearg1-arg2)
    - [DebugTrace()](#debugtrace)
    - [DefineOrRedefineAccessorProperty(arg1, arg2, arg3, arg4, arg5)](#defineorredefineaccessorpropertyarg1-arg2-arg3-arg4-arg5)
    - [DefineOrRedefineDataProperty(arg1, arg2, arg3, arg4)](#defineorredefinedatapropertyarg1-arg2-arg3-arg4)
    - [DeleteProperty(arg1, arg2, arg3)](#deletepropertyarg1-arg2-arg3)
    - [DeoptimizeFunction(arg1)](#deoptimizefunctionarg1)
    - [DisableAccessChecks(arg1)](#disableaccesschecksarg1)
    - [DoubleHi(arg1)](#doublehiarg1)
    - [DoubleLo(arg1)](#doubleloarg1)
    - [EnableAccessChecks(arg1)](#enableaccesschecksarg1)
    - [EstimateNumberOfElements(arg1)](#estimatenumberofelementsarg1)
    - [ExecuteInDebugContext(arg1, arg2)](#executeindebugcontextarg1-arg2)
    - [FinishArrayPrototypeSetup(arg1)](#finisharrayprototypesetuparg1)
    - [Fix(arg1)](#fixarg1)
    - [FlattenString(arg1)](#flattenstringarg1)
    - [FunctionBindArguments(arg1, arg2, arg3, arg4)](#functionbindargumentsarg1-arg2-arg3-arg4)
    - [FunctionGetInferredName(arg1)](#functiongetinferrednamearg1)
    - [FunctionGetName(arg1)](#functiongetnamearg1)
    - [FunctionGetPositionForOffset(arg1, arg2)](#functiongetpositionforoffsetarg1-arg2)
    - [FunctionGetScript(arg1)](#functiongetscriptarg1)
    - [FunctionGetScriptSourcePosition(arg1)](#functiongetscriptsourcepositionarg1)
    - [FunctionGetSourceCode(arg1)](#functiongetsourcecodearg1)
    - [FunctionIsAPIFunction(arg1)](#functionisapifunctionarg1)
    - [FunctionIsBuiltin(arg1)](#functionisbuiltinarg1)
    - [FunctionIsGenerator(arg1)](#functionisgeneratorarg1)
    - [FunctionMarkNameShouldPrintAsAnonymous(arg1)](#functionmarknameshouldprintasanonymousarg1)
    - [FunctionNameShouldPrintAsAnonymous(arg1)](#functionnameshouldprintasanonymousarg1)
    - [FunctionRemovePrototype(arg1)](#functionremoveprototypearg1)
    - [FunctionSetInstanceClassName(arg1, arg2)](#functionsetinstanceclassnamearg1-arg2)
    - [FunctionSetLength(arg1, arg2)](#functionsetlengtharg1-arg2)
    - [FunctionSetName(arg1, arg2)](#functionsetnamearg1-arg2)
    - [FunctionSetPrototype(arg1, arg2)](#functionsetprototypearg1-arg2)
    - [FunctionSetReadOnlyPrototype(arg1)](#functionsetreadonlyprototypearg1)
    - [GeneratorNext(arg1, arg2)](#generatornextarg1-arg2)
    - [GetAllScopesDetails(arg1, arg2, arg3, arg4)](#getallscopesdetailsarg1-arg2-arg3-arg4)
    - [GetAndClearOverflowedStackTrace(arg1)](#getandclearoverflowedstacktracearg1)
    - [GetArgumentsProperty(arg1)](#getargumentspropertyarg1)
    - [GetArrayKeys(arg1, arg2)](#getarraykeysarg1-arg2)
    - [GetBreakLocations(arg1, arg2)](#getbreaklocationsarg1-arg2)
    - [GetCallTrap(arg1)](#getcalltraparg1)
    - [GetConstructorDelegate(arg1)](#getconstructordelegatearg1)
    - [GetConstructTrap(arg1)](#getconstructtraparg1)
    - [GetDataProperty(arg1, arg2)](#getdatapropertyarg1-arg2)
    - [GetDefaultReceiver(arg1)](#getdefaultreceiverarg1)
    - [GetFrameCount(arg1)](#getframecountarg1)
    - [GetFrameDetails(arg1, arg2)](#getframedetailsarg1-arg2)
    - [GetFunctionCodePositionFromSource(arg1, arg2)](#getfunctioncodepositionfromsourcearg1-arg2)
    - [GetFunctionDelegate(arg1)](#getfunctiondelegatearg1)
    - [GetFunctionScopeCount(arg1)](#getfunctionscopecountarg1)
    - [GetFunctionScopeDetails(arg1, arg2)](#getfunctionscopedetailsarg1-arg2)
    - [GetHandler(arg1)](#gethandlerarg1)
    - [GetHeapUsage()](#getheapusage)
    - [GetIndexedInterceptorElementNames(arg1)](#getindexedinterceptorelementnamesarg1)
    - [GetInterceptorInfo(arg1)](#getinterceptorinfoarg1)
    - [GetLocalElementNames(arg1)](#getlocalelementnamesarg1)
    - [GetLocalPropertyNames(arg1, arg2)](#getlocalpropertynamesarg1-arg2)
    - [GetMicrotaskState()](#getmicrotaskstate)
    - [GetNamedInterceptorPropertyNames(arg1)](#getnamedinterceptorpropertynamesarg1)
    - [GetObservationState()](#getobservationstate)
    - [GetOptimizationCount(arg1)](#getoptimizationcountarg1)
    - [GetOwnProperty(arg1, arg2)](#getownpropertyarg1-arg2)
    - [GetProperty(arg1, arg2)](#getpropertyarg1-arg2)
    - [GetPropertyNames(arg1)](#getpropertynamesarg1)
    - [GetPropertyNamesFast(arg1)](#getpropertynamesfastarg1)
    - [GetPrototype(arg1)](#getprototypearg1)
    - [GetRootNaN()](#getrootnan)
    - [GetScopeCount(arg1, arg2)](#getscopecountarg1-arg2)
    - [GetScopeDetails(arg1, arg2, arg3, arg4)](#getscopedetailsarg1-arg2-arg3-arg4)
    - [GetScript(arg1)](#getscriptarg1)
    - [GetStepInPositions(arg1, arg2)](#getstepinpositionsarg1-arg2)
    - [GetTemplateField(arg1, arg2)](#gettemplatefieldarg1-arg2)
    - [GetThreadCount(arg1)](#getthreadcountarg1)
    - [GetThreadDetails(arg1, arg2)](#getthreaddetailsarg1-arg2)
    - [GetV8Version()](#getv8version)
    - [GlobalPrint(arg1)](#globalprintarg1)
    - [GlobalReceiver(arg1)](#globalreceiverarg1)
    - [HasDictionaryElements(arg1)](#hasdictionaryelementsarg1)
    - [HasElement(arg1, arg2)](#haselementarg1-arg2)
    - [HasExternalArrayElements(arg1)](#hasexternalarrayelementsarg1)
    - [HasExternalFloat32Elements(arg1)](#hasexternalfloat32elementsarg1)
    - [HasExternalFloat64Elements(arg1)](#hasexternalfloat64elementsarg1)
    - [HasExternalInt8Elements(arg1)](#hasexternalint8elementsarg1)
    - [HasExternalInt16Elements(arg1)](#hasexternalint16elementsarg1)
    - [HasExternalInt32Elements(arg1)](#hasexternalint32elementsarg1)
    - [HasExternalUint8ClampedElements(arg1)](#hasexternaluint8clampedelementsarg1)
    - [HasExternalUint8Elements(arg1)](#hasexternaluint8elementsarg1)
    - [HasExternalUint16Elements(arg1)](#hasexternaluint16elementsarg1)
    - [HasExternalUint32Elements(arg1)](#hasexternaluint32elementsarg1)
    - [HasFastDoubleElements(arg1)](#hasfastdoubleelementsarg1)
    - [HasFastHoleyElements(arg1)](#hasfastholeyelementsarg1)
    - [HasFastObjectElements(arg1)](#hasfastobjectelementsarg1)
    - [HasFastProperties(arg1)](#hasfastpropertiesarg1)
    - [HasFastSmiElements(arg1)](#hasfastsmielementsarg1)
    - [HasFastSmiOrObjectElements(arg1)](#hasfastsmiorobjectelementsarg1)
    - [HasFixedFloat32Elements(arg1)](#hasfixedfloat32elementsarg1)
    - [HasFixedFloat64Elements(arg1)](#hasfixedfloat64elementsarg1)
    - [HasFixedInt8Elements(arg1)](#hasfixedint8elementsarg1)
    - [HasFixedInt16Elements(arg1)](#hasfixedint16elementsarg1)
    - [HasFixedInt32Elements(arg1)](#hasfixedint32elementsarg1)
    - [HasFixedUint8ClampedElements(arg1)](#hasfixeduint8clampedelementsarg1)
    - [HasFixedUint8Elements(arg1)](#hasfixeduint8elementsarg1)
    - [HasFixedUint16Elements(arg1)](#hasfixeduint16elementsarg1)
    - [HasFixedUint32Elements(arg1)](#hasfixeduint32elementsarg1)
    - [HasLocalProperty(arg1, arg2)](#haslocalpropertyarg1-arg2)
    - [HasProperty(arg1, arg2)](#haspropertyarg1-arg2)
    - [HasSloppyArgumentsElements(arg1)](#hassloppyargumentselementsarg1)
    - [HaveSameMap(arg1, arg2)](#havesamemaparg1-arg2)
    - [IS_VAR(arg1)](#is_vararg1)
    - [IsAttachedGlobal(arg1)](#isattachedglobalarg1)
    - [IsBreakOnException(arg1)](#isbreakonexceptionarg1)
    - [IsConcurrentRecompilationSupported()](#isconcurrentrecompilationsupported)
    - [IsExtensible(arg1)](#isextensiblearg1)
    - [IsInPrototypeChain(arg1, arg2)](#isinprototypechainarg1-arg2)
    - [IsJSFunctionProxy(arg1)](#isjsfunctionproxyarg1)
    - [IsJSGlobalProxy(arg1)](#isjsglobalproxyarg1)
    - [IsJSModule(arg1)](#isjsmodulearg1)
    - [IsJSProxy(arg1)](#isjsproxyarg1)
    - [IsMinusZero(arg1)](#isminuszeroarg1)
    - [IsObserved(arg1)](#isobservedarg1)
    - [IsPropertyEnumerable(arg1, arg2)](#ispropertyenumerablearg1-arg2)
    - [IsSloppyModeFunction(arg1)](#issloppymodefunctionarg1)
    - [IsTemplate(arg1)](#istemplatearg1)
    - [IsValidSmi(arg1)](#isvalidsmiarg1)
    - [KeyedGetProperty(arg1, arg2)](#keyedgetpropertyarg1-arg2)
    - [LiveEditCheckAndDropActivations(arg1, arg2)](#liveeditcheckanddropactivationsarg1-arg2)
    - [LiveEditCompareStrings(arg1, arg2)](#liveeditcomparestringsarg1-arg2)
    - [LiveEditFindSharedFunctionInfosForScript(arg1)](#liveeditfindsharedfunctioninfosforscriptarg1)
    - [LiveEditFunctionSetScript(arg1, arg2)](#liveeditfunctionsetscriptarg1-arg2)
    - [LiveEditFunctionSourceUpdated(arg1)](#liveeditfunctionsourceupdatedarg1)
    - [LiveEditGatherCompileInfo(arg1, arg2)](#liveeditgathercompileinfoarg1-arg2)
    - [LiveEditPatchFunctionPositions(arg1, arg2)](#liveeditpatchfunctionpositionsarg1-arg2)
    - [LiveEditReplaceFunctionCode(arg1, arg2)](#liveeditreplacefunctioncodearg1-arg2)
    - [LiveEditReplaceRefToNestedFunction(arg1, arg2, arg3)](#liveeditreplacereftonestedfunctionarg1-arg2-arg3)
    - [LiveEditReplaceScript(arg1, arg2, arg3)](#liveeditreplacescriptarg1-arg2-arg3)
    - [LiveEditRestartFrame(arg1, arg2)](#liveeditrestartframearg1-arg2)
    - [LoadMutableDouble(arg1, arg2)](#loadmutabledoublearg1-arg2)
    - [LocalKeys(arg1)](#localkeysarg1)
    - [LookupAccessor(arg1, arg2, arg3)](#lookupaccessorarg1-arg2-arg3)
    - [MapClear(arg1)](#mapcleararg1)
    - [MapCreateIterator(arg1, arg2)](#mapcreateiteratorarg1-arg2)
    - [MapDelete(arg1, arg2)](#mapdeletearg1-arg2)
    - [MapGet(arg1, arg2)](#mapgetarg1-arg2)
    - [MapGetSize(arg1)](#mapgetsizearg1)
    - [MapHas(arg1, arg2)](#maphasarg1-arg2)
    - [MapInitialize(arg1)](#mapinitializearg1)
    - [MapIteratorClose(arg1)](#mapiteratorclosearg1)
    - [MapIteratorNext(arg1)](#mapiteratornextarg1)
    - [MapSet(arg1, arg2, arg3)](#mapsetarg1-arg2-arg3)
    - [MathAcos(arg1)](#mathacosarg1)
    - [MathAsin(arg1)](#mathasinarg1)
    - [MathAtan(arg1)](#mathatanarg1)
    - [MathAtan2(arg1, arg2)](#mathatan2arg1-arg2)
    - [MathExp(arg1)](#mathexparg1)
    - [MathFloor(arg1)](#mathfloorarg1)
    - [MathFround(arg1)](#mathfroundarg1)
    - [MathLog(arg1)](#mathlogarg1)
    - [MathSqrt(arg1)](#mathsqrtarg1)
    - [MaxSmi()](#maxsmi)
    - [MessageGetScript(arg1)](#messagegetscriptarg1)
    - [MessageGetStartPosition(arg1)](#messagegetstartpositionarg1)
    - [MoveArrayContents(arg1, arg2)](#movearraycontentsarg1-arg2)
    - [NeverOptimizeFunction(arg1)](#neveroptimizefunctionarg1)
    - [NewObjectFromBound(arg1)](#newobjectfromboundarg1)
    - [NewString(arg1, arg2)](#newstringarg1-arg2)
    - [NewStringWrapper(arg1)](#newstringwrapperarg1)
    - [NewSymbolWrapper(arg1)](#newsymbolwrapperarg1)
    - [NotifyContextDisposed()](#notifycontextdisposed)
    - [NumberAdd(arg1, arg2)](#numberaddarg1-arg2)
    - [NumberAnd(arg1, arg2)](#numberandarg1-arg2)
    - [NumberCompare(arg1, arg2, arg3)](#numbercomparearg1-arg2-arg3)
    - [NumberDiv(arg1, arg2)](#numberdivarg1-arg2)
    - [NumberEquals(arg1, arg2)](#numberequalsarg1-arg2)
    - [NumberImul(arg1, arg2)](#numberimularg1-arg2)
    - [NumberMod(arg1, arg2)](#numbermodarg1-arg2)
    - [NumberMul(arg1, arg2)](#numbermularg1-arg2)
    - [NumberOr(arg1, arg2)](#numberorarg1-arg2)
    - [NumberSar(arg1, arg2)](#numbersararg1-arg2)
    - [NumberShl(arg1, arg2)](#numbershlarg1-arg2)
    - [NumberShr(arg1, arg2)](#numbershrarg1-arg2)
    - [NumberSub(arg1, arg2)](#numbersubarg1-arg2)
    - [NumberToExponential(arg1, arg2)](#numbertoexponentialarg1-arg2)
    - [NumberToFixed(arg1, arg2)](#numbertofixedarg1-arg2)
    - [NumberToInteger(arg1)](#numbertointegerarg1)
    - [NumberToIntegerMapMinusZero(arg1)](#numbertointegermapminuszeroarg1)
    - [NumberToJSInt32(arg1)](#numbertojsint32arg1)
    - [NumberToJSUint32(arg1)](#numbertojsuint32arg1)
    - [NumberToPrecision(arg1, arg2)](#numbertoprecisionarg1-arg2)
    - [NumberToRadixString(arg1, arg2)](#numbertoradixstringarg1-arg2)
    - [NumberUnaryMinus(arg1)](#numberunaryminusarg1)
    - [NumberXor(arg1, arg2)](#numberxorarg1-arg2)
    - [ObjectFreeze(arg1)](#objectfreezearg1)
    - [ObjectGetNotifierInObjectContext(arg1)](#objectgetnotifierinobjectcontextarg1)
    - [ObjectNotifierPerformChangeInObjectContext(arg1, arg2, arg3)](#objectnotifierperformchangeinobjectcontextarg1-arg2-arg3)
    - [ObjectObserveInObjectContext(arg1, arg2, arg3)](#objectobserveinobjectcontextarg1-arg2-arg3)
    - [ObjectWasCreatedInCurrentOrigin(arg1)](#objectwascreatedincurrentoriginarg1)
    - [ObservationWeakMapCreate()](#observationweakmapcreate)
    - [ObserverObjectAndRecordHaveSameOrigin(arg1, arg2, arg3)](#observerobjectandrecordhavesameoriginarg1-arg2-arg3)
    - [OneByteSeqStringSetChar(arg1, arg2, arg3)](#onebyteseqstringsetchararg1-arg2-arg3)
    - [OptimizeObjectForAddingMultipleProperties(arg1, arg2)](#optimizeobjectforaddingmultiplepropertiesarg1-arg2)
    - [ParseJson(arg1)](#parsejsonarg1)
    - [PrepareStep(arg1, arg2, arg3, arg4)](#preparesteparg1-arg2-arg3-arg4)
    - [PreventExtensions(arg1)](#preventextensionsarg1)
    - [PushIfAbsent(arg1, arg2)](#pushifabsentarg1-arg2)
    - [QuoteJSONString(arg1)](#quotejsonstringarg1)
    - [RegExpCompile(arg1, arg2, arg3)](#regexpcompilearg1-arg2-arg3)
    - [RegExpExecMultiple(arg1, arg2, arg3, arg4)](#regexpexecmultiplearg1-arg2-arg3-arg4)
    - [RegExpInitializeObject(arg1, arg2, arg3, arg4, arg5)](#regexpinitializeobjectarg1-arg2-arg3-arg4-arg5)
    - [RemoveArrayHoles(arg1, arg2)](#removearrayholesarg1-arg2)
    - [RoundNumber(arg1)](#roundnumberarg1)
    - [RunMicrotasks()](#runmicrotasks)
    - [RunningInSimulator()](#runninginsimulator)
    - [SetAccessorProperty(arg1, arg2, arg3, arg4, arg5, arg6)](#setaccessorpropertyarg1-arg2-arg3-arg4-arg5-arg6)
    - [SetAdd(arg1, arg2)](#setaddarg1-arg2)
    - [SetClear(arg1)](#setcleararg1)
    - [SetCode(arg1, arg2)](#setcodearg1-arg2)
    - [SetCreateIterator(arg1, arg2)](#setcreateiteratorarg1-arg2)
    - [SetDebugEventListener(arg1, arg2)](#setdebugeventlistenerarg1-arg2)
    - [SetDelete(arg1, arg2)](#setdeletearg1-arg2)
    - [SetDisableBreak(arg1)](#setdisablebreakarg1)
    - [SetExpectedNumberOfProperties(arg1, arg2)](#setexpectednumberofpropertiesarg1-arg2)
    - [SetFlags(arg1)](#setflagsarg1)
    - [SetFunctionBreakPoint(arg1, arg2, arg3)](#setfunctionbreakpointarg1-arg2-arg3)
    - [SetGetSize(arg1)](#setgetsizearg1)
    - [SetHas(arg1, arg2)](#sethasarg1-arg2)
    - [SetHiddenProperty(arg1, arg2, arg3)](#sethiddenpropertyarg1-arg2-arg3)
    - [SetInitialize(arg1)](#setinitializearg1)
    - [SetInlineBuiltinFlag(arg1)](#setinlinebuiltinflagarg1)
    - [SetIsObserved(arg1)](#setisobservedarg1)
    - [SetIteratorClose(arg1)](#setiteratorclosearg1)
    - [SetIteratorNext(arg1)](#setiteratornextarg1)
    - [SetMicrotaskPending(arg1)](#setmicrotaskpendingarg1)
    - [SetNativeFlag(arg1)](#setnativeflagarg1)
    - [SetPrototype(arg1, arg2)](#setprototypearg1-arg2)
    - [SetScopeVariableValue(arg1, arg2, arg3, arg4, arg5, arg6)](#setscopevariablevaluearg1-arg2-arg3-arg4-arg5-arg6)
    - [SetScriptBreakPoint(arg1, arg2, arg3, arg4)](#setscriptbreakpointarg1-arg2-arg3-arg4)
    - [SmiLexicographicCompare(arg1, arg2)](#smilexicographiccomparearg1-arg2)
    - [SparseJoinWithSeparator(arg1, arg2, arg3)](#sparsejoinwithseparatorarg1-arg2-arg3)
    - [SpecialArrayFunctions(arg1)](#specialarrayfunctionsarg1)
    - [StoreArrayLiteralElement(arg1, arg2, arg3, arg4, arg5)](#storearrayliteralelementarg1-arg2-arg3-arg4-arg5)
    - [StringBuilderConcat(arg1, arg2, arg3)](#stringbuilderconcatarg1-arg2-arg3)
    - [StringBuilderJoin(arg1, arg2, arg3)](#stringbuilderjoinarg1-arg2-arg3)
    - [StringEquals(arg1, arg2)](#stringequalsarg1-arg2)
    - [StringIndexOf(arg1, arg2, arg3)](#stringindexofarg1-arg2-arg3)
    - [StringLastIndexOf(arg1, arg2, arg3)](#stringlastindexofarg1-arg2-arg3)
    - [StringLocaleCompare(arg1, arg2)](#stringlocalecomparearg1-arg2)
    - [StringMatch(arg1, arg2, arg3)](#stringmatcharg1-arg2-arg3)
    - [StringParseFloat(arg1)](#stringparsefloatarg1)
    - [StringParseInt(arg1, arg2)](#stringparseintarg1-arg2)
    - [StringReplaceGlobalRegExpWithString(arg1, arg2, arg3, arg4)](#stringreplaceglobalregexpwithstringarg1-arg2-arg3-arg4)
    - [StringReplaceOneCharWithString(arg1, arg2, arg3)](#stringreplaceonecharwithstringarg1-arg2-arg3)
    - [StringSplit(arg1, arg2, arg3)](#stringsplitarg1-arg2-arg3)
    - [StringToArray(arg1, arg2)](#stringtoarrayarg1-arg2)
    - [StringToLowerCase(arg1)](#stringtolowercasearg1)
    - [StringToNumber(arg1)](#stringtonumberarg1)
    - [StringToUpperCase(arg1)](#stringtouppercasearg1)
    - [StringTrim(arg1, arg2, arg3)](#stringtrimarg1-arg2-arg3)
    - [SymbolDescription(arg1)](#symboldescriptionarg1)
    - [SymbolIsPrivate(arg1)](#symbolisprivatearg1)
    - [SymbolRegistry()](#symbolregistry)
    - [SystemBreak()](#systembreak)
    - [ToBool(arg1)](#toboolarg1)
    - [ToFastProperties(arg1)](#tofastpropertiesarg1)
    - [TraceEnter()](#traceenter)
    - [TraceExit(arg1)](#traceexitarg1)
    - [TransitionElementsKind(arg1, arg2)](#transitionelementskindarg1-arg2)
    - [TruncateString(arg1, arg2)](#truncatestringarg1-arg2)
    - [TryMigrateInstance(arg1)](#trymigrateinstancearg1)
    - [TwoByteSeqStringSetChar(arg1, arg2, arg3)](#twobyteseqstringsetchararg1-arg2-arg3)
    - [TypedArrayGetBuffer(arg1)](#typedarraygetbufferarg1)
    - [TypedArrayGetLength(arg1)](#typedarraygetlengtharg1)
    - [TypedArrayInitialize(arg1, arg2, arg3, arg4, arg5)](#typedarrayinitializearg1-arg2-arg3-arg4-arg5)
    - [TypedArrayInitializeFromArrayLike(arg1, arg2, arg3, arg4)](#typedarrayinitializefromarraylikearg1-arg2-arg3-arg4)
    - [TypedArrayMaxSizeInHeap()](#typedarraymaxsizeinheap)
    - [TypedArraySetFastCases(arg1, arg2, arg3)](#typedarraysetfastcasesarg1-arg2-arg3)
    - [Typeof(arg1)](#typeofarg1)
    - [UnblockConcurrentRecompilation()](#unblockconcurrentrecompilation)
    - [URIEscape(arg1)](#uriescapearg1)
    - [URIUnescape(arg1)](#uriunescapearg1)
    - [WeakCollectionDelete(arg1, arg2)](#weakcollectiondeletearg1-arg2)
    - [WeakCollectionGet(arg1, arg2)](#weakcollectiongetarg1-arg2)
    - [WeakCollectionHas(arg1, arg2)](#weakcollectionhasarg1-arg2)
    - [WeakCollectionInitialize(arg1)](#weakcollectioninitializearg1)
    - [WeakCollectionSet(arg1, arg2, arg3)](#weakcollectionsetarg1-arg2-arg3)
  - [License](#license)

<!-- END doctoc generated TOC please keep comment here to allow auto update -->

## API


<!-- START docme generated API please keep comment here to allow auto update -->
<!-- DON'T EDIT THIS SECTION, INSTEAD RE-RUN docme TO UPDATE -->

<div>
<div class="jsdoc-githubify">
<section>
<article>
<div class="container-overview">
<dl class="details">
</dl>
</div>
<dl>
<dt>
<h4 class="name" id="_Arguments"><span class="type-signature"></span>_Arguments<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5148">lineno 5148</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_ArgumentsLength"><span class="type-signature"></span>_ArgumentsLength<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5135">lineno 5135</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_ClassOf"><span class="type-signature"></span>_ClassOf<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5452">lineno 5452</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_FastAsciiArrayJoin"><span class="type-signature"></span>_FastAsciiArrayJoin<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5394">lineno 5394</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_GeneratorThrow"><span class="type-signature"></span>_GeneratorThrow<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5424">lineno 5424</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_GetCachedArrayIndex"><span class="type-signature"></span>_GetCachedArrayIndex<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5380">lineno 5380</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_GetFromCache"><span class="type-signature"></span>_GetFromCache<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5560">lineno 5560</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_HasCachedArrayIndex"><span class="type-signature"></span>_HasCachedArrayIndex<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5366">lineno 5366</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsArray"><span class="type-signature"></span>_IsArray<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5094">lineno 5094</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsConstructCall"><span class="type-signature"></span>_IsConstructCall<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5122">lineno 5122</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsFunction"><span class="type-signature"></span>_IsFunction<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5281">lineno 5281</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsNonNegativeSmi"><span class="type-signature"></span>_IsNonNegativeSmi<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5080">lineno 5080</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsObject"><span class="type-signature"></span>_IsObject<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5267">lineno 5267</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsRegExp"><span class="type-signature"></span>_IsRegExp<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5108">lineno 5108</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsSmi"><span class="type-signature"></span>_IsSmi<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5066">lineno 5066</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsSpecObject"><span class="type-signature"></span>_IsSpecObject<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5309">lineno 5309</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsStringWrapperSafeForDefaultValueOf"><span class="type-signature"></span>_IsStringWrapperSafeForDefaultValueOf<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5323">lineno 5323</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_IsUndetectableObject"><span class="type-signature"></span>_IsUndetectableObject<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5295">lineno 5295</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_MathPow"><span class="type-signature"></span>_MathPow<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5337">lineno 5337</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_NumberToString"><span class="type-signature"></span>_NumberToString<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5575">lineno 5575</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_ObjectEquals"><span class="type-signature"></span>_ObjectEquals<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5252">lineno 5252</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_RegExpConstructResult"><span class="type-signature"></span>_RegExpConstructResult<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5544">lineno 5544</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_RegExpExec"><span class="type-signature"></span>_RegExpExec<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5527">lineno 5527</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_SetValueOf"><span class="type-signature"></span>_SetValueOf<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5176">lineno 5176</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_StringAdd"><span class="type-signature"></span>_StringAdd<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5481">lineno 5481</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_StringCharAt"><span class="type-signature"></span>_StringCharAt<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5205">lineno 5205</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_StringCharCodeAt"><span class="type-signature"></span>_StringCharCodeAt<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5466">lineno 5466</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_StringCharFromCode"><span class="type-signature"></span>_StringCharFromCode<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5191">lineno 5191</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_StringCompare"><span class="type-signature"></span>_StringCompare<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5512">lineno 5512</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_SubString"><span class="type-signature"></span>_SubString<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5496">lineno 5496</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="_ValueOf"><span class="type-signature"></span>_ValueOf<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5162">lineno 5162</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="Abort"><span class="type-signature"></span>Abort<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented
BREAKS due to immediate execution</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3678">lineno 3678</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="AbortJS"><span class="type-signature"></span>AbortJS<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3693">lineno 3693</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="Apply"><span class="type-signature"></span>Apply<span class="signature">(arg1, arg2, arg3, arg4, arg5)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L417">lineno 417</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayBufferGetByteLength"><span class="type-signature"></span>ArrayBufferGetByteLength<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5692">lineno 5692</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayBufferInitialize"><span class="type-signature"></span>ArrayBufferInitialize<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3197">lineno 3197</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayBufferIsView"><span class="type-signature"></span>ArrayBufferIsView<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3228">lineno 3228</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayBufferNeuter"><span class="type-signature"></span>ArrayBufferNeuter<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3242">lineno 3242</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayBufferSliceImpl"><span class="type-signature"></span>ArrayBufferSliceImpl<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3212">lineno 3212</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayBufferViewGetByteLength"><span class="type-signature"></span>ArrayBufferViewGetByteLength<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5650">lineno 5650</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayBufferViewGetByteOffset"><span class="type-signature"></span>ArrayBufferViewGetByteOffset<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5664">lineno 5664</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ArrayConcat"><span class="type-signature"></span>ArrayConcat<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L730">lineno 730</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="BasicJSONStringify"><span class="type-signature"></span>BasicJSONStringify<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1438">lineno 1438</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="BoundFunctionGetBindings"><span class="type-signature"></span>BoundFunctionGetBindings<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1858">lineno 1858</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="Break"><span class="type-signature"></span>Break<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4214">lineno 4214</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ChangeBreakOnException"><span class="type-signature"></span>ChangeBreakOnException<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4604">lineno 4604</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CharFromCode"><span class="type-signature"></span>CharFromCode<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L859">lineno 859</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CheckExecutionState"><span class="type-signature"></span>CheckExecutionState<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4329">lineno 4329</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CheckIsBootstrapping"><span class="type-signature"></span>CheckIsBootstrapping<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L391">lineno 391</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ClearBreakPoint"><span class="type-signature"></span>ClearBreakPoint<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4590">lineno 4590</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ClearFunctionTypeFeedback"><span class="type-signature"></span>ClearFunctionTypeFeedback<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L477">lineno 477</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ClearStepping"><span class="type-signature"></span>ClearStepping<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4651">lineno 4651</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CollectGarbage"><span class="type-signature"></span>CollectGarbage<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5037">lineno 5037</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CollectStackTrace"><span class="type-signature"></span>CollectStackTrace<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1985">lineno 1985</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CompileForOnStackReplacement"><span class="type-signature"></span>CompileForOnStackReplacement<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L558">lineno 558</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CompileString"><span class="type-signature"></span>CompileString<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented
BREAKS due to immediate execution</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2250">lineno 2250</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ConstructDouble"><span class="type-signature"></span>ConstructDouble<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5706">lineno 5706</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CreateApiFunction"><span class="type-signature"></span>CreateApiFunction<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented
BREAKS due to immediate execution</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2058">lineno 2058</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CreateGlobalPrivateSymbol"><span class="type-signature"></span>CreateGlobalPrivateSymbol<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2504">lineno 2504</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CreateJSFunctionProxy"><span class="type-signature"></span>CreateJSFunctionProxy<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2588">lineno 2588</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CreateJSProxy"><span class="type-signature"></span>CreateJSProxy<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2573">lineno 2573</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CreatePrivateSymbol"><span class="type-signature"></span>CreatePrivateSymbol<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2490">lineno 2490</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="CreateSymbol"><span class="type-signature"></span>CreateSymbol<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2476">lineno 2476</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetBuffer"><span class="type-signature"></span>DataViewGetBuffer<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3303">lineno 3303</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetFloat32"><span class="type-signature"></span>DataViewGetFloat32<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3413">lineno 3413</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetFloat64"><span class="type-signature"></span>DataViewGetFloat64<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3429">lineno 3429</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetInt8"><span class="type-signature"></span>DataViewGetInt8<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3317">lineno 3317</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetInt16"><span class="type-signature"></span>DataViewGetInt16<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3349">lineno 3349</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetInt32"><span class="type-signature"></span>DataViewGetInt32<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3381">lineno 3381</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetUint8"><span class="type-signature"></span>DataViewGetUint8<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3333">lineno 3333</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetUint16"><span class="type-signature"></span>DataViewGetUint16<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3365">lineno 3365</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewGetUint32"><span class="type-signature"></span>DataViewGetUint32<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3397">lineno 3397</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewInitialize"><span class="type-signature"></span>DataViewInitialize<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5607">lineno 5607</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetFloat32"><span class="type-signature"></span>DataViewSetFloat32<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3547">lineno 3547</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetFloat64"><span class="type-signature"></span>DataViewSetFloat64<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3564">lineno 3564</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetInt8"><span class="type-signature"></span>DataViewSetInt8<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3445">lineno 3445</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetInt16"><span class="type-signature"></span>DataViewSetInt16<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3479">lineno 3479</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetInt32"><span class="type-signature"></span>DataViewSetInt32<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3513">lineno 3513</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetUint8"><span class="type-signature"></span>DataViewSetUint8<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3462">lineno 3462</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetUint16"><span class="type-signature"></span>DataViewSetUint16<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3496">lineno 3496</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DataViewSetUint32"><span class="type-signature"></span>DataViewSetUint32<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3530">lineno 3530</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DateCacheVersion"><span class="type-signature"></span>DateCacheVersion<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2237">lineno 2237</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DateCurrentTime"><span class="type-signature"></span>DateCurrentTime<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2150">lineno 2150</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DateLocalTimezone"><span class="type-signature"></span>DateLocalTimezone<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2178">lineno 2178</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DateMakeDay"><span class="type-signature"></span>DateMakeDay<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2206">lineno 2206</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DateParseString"><span class="type-signature"></span>DateParseString<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2163">lineno 2163</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DateSetValue"><span class="type-signature"></span>DateSetValue<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2221">lineno 2221</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DateToUTC"><span class="type-signature"></span>DateToUTC<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2192">lineno 2192</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugBreak"><span class="type-signature"></span>DebugBreak<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4186">lineno 4186</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugBreakInOptimizedCode"><span class="type-signature"></span>DebugBreakInOptimizedCode<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5439">lineno 5439</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugCallbackSupportsStepping"><span class="type-signature"></span>DebugCallbackSupportsStepping<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5777">lineno 5777</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugConstructedBy"><span class="type-signature"></span>DebugConstructedBy<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4729">lineno 4729</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugDisassembleConstructor"><span class="type-signature"></span>DebugDisassembleConstructor<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4800">lineno 4800</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugDisassembleFunction"><span class="type-signature"></span>DebugDisassembleFunction<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4786">lineno 4786</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugEvaluate"><span class="type-signature"></span>DebugEvaluate<span class="signature">(arg1, arg2, arg3, arg4, arg5, arg6)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg6</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4664">lineno 4664</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugEvaluateGlobal"><span class="type-signature"></span>DebugEvaluateGlobal<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4683">lineno 4683</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugGetLoadedScripts"><span class="type-signature"></span>DebugGetLoadedScripts<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4700">lineno 4700</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugGetProperty"><span class="type-signature"></span>DebugGetProperty<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4242">lineno 4242</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugGetPropertyDetails"><span class="type-signature"></span>DebugGetPropertyDetails<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4227">lineno 4227</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugGetPrototype"><span class="type-signature"></span>DebugGetPrototype<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4744">lineno 4744</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugIndexedInterceptorElementValue"><span class="type-signature"></span>DebugIndexedInterceptorElementValue<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4314">lineno 4314</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugNamedInterceptorPropertyValue"><span class="type-signature"></span>DebugNamedInterceptorPropertyValue<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4299">lineno 4299</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPrepareStepInIfStepping"><span class="type-signature"></span>DebugPrepareStepInIfStepping<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L618">lineno 618</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPrint"><span class="type-signature"></span>DebugPrint<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3610">lineno 3610</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPrintScopes"><span class="type-signature"></span>DebugPrintScopes<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4484">lineno 4484</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPromiseHandleEpilogue"><span class="type-signature"></span>DebugPromiseHandleEpilogue<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L646">lineno 646</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPromiseHandlePrologue"><span class="type-signature"></span>DebugPromiseHandlePrologue<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L632">lineno 632</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPropertyAttributesFromDetails"><span class="type-signature"></span>DebugPropertyAttributesFromDetails<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4271">lineno 4271</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPropertyIndexFromDetails"><span class="type-signature"></span>DebugPropertyIndexFromDetails<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4285">lineno 4285</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugPropertyTypeFromDetails"><span class="type-signature"></span>DebugPropertyTypeFromDetails<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4257">lineno 4257</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugReferencedBy"><span class="type-signature"></span>DebugReferencedBy<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4713">lineno 4713</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugSetScriptSource"><span class="type-signature"></span>DebugSetScriptSource<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4758">lineno 4758</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DebugTrace"><span class="type-signature"></span>DebugTrace<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3638">lineno 3638</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DefineOrRedefineAccessorProperty"><span class="type-signature"></span>DefineOrRedefineAccessorProperty<span class="signature">(arg1, arg2, arg3, arg4, arg5)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2311">lineno 2311</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DefineOrRedefineDataProperty"><span class="type-signature"></span>DefineOrRedefineDataProperty<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2294">lineno 2294</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DeleteProperty"><span class="type-signature"></span>DeleteProperty<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L44">lineno 44</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DeoptimizeFunction"><span class="type-signature"></span>DeoptimizeFunction<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L463">lineno 463</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DisableAccessChecks"><span class="type-signature"></span>DisableAccessChecks<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2103">lineno 2103</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DoubleHi"><span class="type-signature"></span>DoubleHi<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5721">lineno 5721</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="DoubleLo"><span class="type-signature"></span>DoubleLo<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5735">lineno 5735</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="EnableAccessChecks"><span class="type-signature"></span>EnableAccessChecks<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2117">lineno 2117</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="EstimateNumberOfElements"><span class="type-signature"></span>EstimateNumberOfElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2405">lineno 2405</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ExecuteInDebugContext"><span class="type-signature"></span>ExecuteInDebugContext<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5008">lineno 5008</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FinishArrayPrototypeSetup"><span class="type-signature"></span>FinishArrayPrototypeSetup<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L248">lineno 248</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="Fix"><span class="type-signature"></span>Fix<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2675">lineno 2675</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FlattenString"><span class="type-signature"></span>FlattenString<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L659">lineno 659</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionBindArguments"><span class="type-signature"></span>FunctionBindArguments<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1841">lineno 1841</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionGetInferredName"><span class="type-signature"></span>FunctionGetInferredName<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4814">lineno 4814</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionGetName"><span class="type-signature"></span>FunctionGetName<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1770">lineno 1770</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionGetPositionForOffset"><span class="type-signature"></span>FunctionGetPositionForOffset<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1928">lineno 1928</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionGetScript"><span class="type-signature"></span>FunctionGetScript<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1900">lineno 1900</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionGetScriptSourcePosition"><span class="type-signature"></span>FunctionGetScriptSourcePosition<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1914">lineno 1914</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionGetSourceCode"><span class="type-signature"></span>FunctionGetSourceCode<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1886">lineno 1886</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionIsAPIFunction"><span class="type-signature"></span>FunctionIsAPIFunction<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1943">lineno 1943</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionIsBuiltin"><span class="type-signature"></span>FunctionIsBuiltin<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1957">lineno 1957</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionIsGenerator"><span class="type-signature"></span>FunctionIsGenerator<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1827">lineno 1827</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionMarkNameShouldPrintAsAnonymous"><span class="type-signature"></span>FunctionMarkNameShouldPrintAsAnonymous<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1813">lineno 1813</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionNameShouldPrintAsAnonymous"><span class="type-signature"></span>FunctionNameShouldPrintAsAnonymous<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1799">lineno 1799</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionRemovePrototype"><span class="type-signature"></span>FunctionRemovePrototype<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1872">lineno 1872</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionSetInstanceClassName"><span class="type-signature"></span>FunctionSetInstanceClassName<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1711">lineno 1711</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionSetLength"><span class="type-signature"></span>FunctionSetLength<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1726">lineno 1726</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionSetName"><span class="type-signature"></span>FunctionSetName<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1784">lineno 1784</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionSetPrototype"><span class="type-signature"></span>FunctionSetPrototype<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1741">lineno 1741</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="FunctionSetReadOnlyPrototype"><span class="type-signature"></span>FunctionSetReadOnlyPrototype<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1756">lineno 1756</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GeneratorNext"><span class="type-signature"></span>GeneratorNext<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5409">lineno 5409</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetAllScopesDetails"><span class="type-signature"></span>GetAllScopesDetails<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4419">lineno 4419</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetAndClearOverflowedStackTrace"><span class="type-signature"></span>GetAndClearOverflowedStackTrace<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2001">lineno 2001</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetArgumentsProperty"><span class="type-signature"></span>GetArgumentsProperty<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L220">lineno 220</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetArrayKeys"><span class="type-signature"></span>GetArrayKeys<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2375">lineno 2375</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetBreakLocations"><span class="type-signature"></span>GetBreakLocations<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented
BREAKS due to immediate execution</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4540">lineno 4540</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetCallTrap"><span class="type-signature"></span>GetCallTrap<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2647">lineno 2647</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetConstructorDelegate"><span class="type-signature"></span>GetConstructorDelegate<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L449">lineno 449</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetConstructTrap"><span class="type-signature"></span>GetConstructTrap<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2661">lineno 2661</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetDataProperty"><span class="type-signature"></span>GetDataProperty<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2329">lineno 2329</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetDefaultReceiver"><span class="type-signature"></span>GetDefaultReceiver<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L290">lineno 290</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetFrameCount"><span class="type-signature"></span>GetFrameCount<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4343">lineno 4343</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetFrameDetails"><span class="type-signature"></span>GetFrameDetails<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4357">lineno 4357</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetFunctionCodePositionFromSource"><span class="type-signature"></span>GetFunctionCodePositionFromSource<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4993">lineno 4993</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetFunctionDelegate"><span class="type-signature"></span>GetFunctionDelegate<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L435">lineno 435</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetFunctionScopeCount"><span class="type-signature"></span>GetFunctionScopeCount<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4436">lineno 4436</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetFunctionScopeDetails"><span class="type-signature"></span>GetFunctionScopeDetails<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4450">lineno 4450</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetHandler"><span class="type-signature"></span>GetHandler<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2633">lineno 2633</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetHeapUsage"><span class="type-signature"></span>GetHeapUsage<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5051">lineno 5051</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetIndexedInterceptorElementNames"><span class="type-signature"></span>GetIndexedInterceptorElementNames<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L206">lineno 206</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetInterceptorInfo"><span class="type-signature"></span>GetInterceptorInfo<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L178">lineno 178</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetLocalElementNames"><span class="type-signature"></span>GetLocalElementNames<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L164">lineno 164</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetLocalPropertyNames"><span class="type-signature"></span>GetLocalPropertyNames<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented
BREAKS due to immediate execution</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L148">lineno 148</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetMicrotaskState"><span class="type-signature"></span>GetMicrotaskState<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2449">lineno 2449</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetNamedInterceptorPropertyNames"><span class="type-signature"></span>GetNamedInterceptorPropertyNames<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L192">lineno 192</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetObservationState"><span class="type-signature"></span>GetObservationState<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3095">lineno 3095</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetOptimizationCount"><span class="type-signature"></span>GetOptimizationCount<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L531">lineno 531</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetOwnProperty"><span class="type-signature"></span>GetOwnProperty<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L348">lineno 348</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetProperty"><span class="type-signature"></span>GetProperty<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L14">lineno 14</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetPropertyNames"><span class="type-signature"></span>GetPropertyNames<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L120">lineno 120</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetPropertyNamesFast"><span class="type-signature"></span>GetPropertyNamesFast<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L134">lineno 134</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetPrototype"><span class="type-signature"></span>GetPrototype<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L304">lineno 304</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetRootNaN"><span class="type-signature"></span>GetRootNaN<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L404">lineno 404</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetScopeCount"><span class="type-signature"></span>GetScopeCount<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4372">lineno 4372</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetScopeDetails"><span class="type-signature"></span>GetScopeDetails<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4402">lineno 4402</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetScript"><span class="type-signature"></span>GetScript<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1971">lineno 1971</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetStepInPositions"><span class="type-signature"></span>GetStepInPositions<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4387">lineno 4387</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetTemplateField"><span class="type-signature"></span>GetTemplateField<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2088">lineno 2088</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetThreadCount"><span class="type-signature"></span>GetThreadCount<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4497">lineno 4497</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetThreadDetails"><span class="type-signature"></span>GetThreadDetails<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4511">lineno 4511</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GetV8Version"><span class="type-signature"></span>GetV8Version<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2015">lineno 2015</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GlobalPrint"><span class="type-signature"></span>GlobalPrint<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3624">lineno 3624</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="GlobalReceiver"><span class="type-signature"></span>GlobalReceiver<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2266">lineno 2266</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasDictionaryElements"><span class="type-signature"></span>HasDictionaryElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3833">lineno 3833</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasElement"><span class="type-signature"></span>HasElement<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L90">lineno 90</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalArrayElements"><span class="type-signature"></span>HasExternalArrayElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3875">lineno 3875</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalFloat32Elements"><span class="type-signature"></span>HasExternalFloat32Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3973">lineno 3973</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalFloat64Elements"><span class="type-signature"></span>HasExternalFloat64Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3987">lineno 3987</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalInt8Elements"><span class="type-signature"></span>HasExternalInt8Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3889">lineno 3889</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalInt16Elements"><span class="type-signature"></span>HasExternalInt16Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3917">lineno 3917</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalInt32Elements"><span class="type-signature"></span>HasExternalInt32Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3945">lineno 3945</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalUint8ClampedElements"><span class="type-signature"></span>HasExternalUint8ClampedElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3861">lineno 3861</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalUint8Elements"><span class="type-signature"></span>HasExternalUint8Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3903">lineno 3903</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalUint16Elements"><span class="type-signature"></span>HasExternalUint16Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3931">lineno 3931</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasExternalUint32Elements"><span class="type-signature"></span>HasExternalUint32Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3959">lineno 3959</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFastDoubleElements"><span class="type-signature"></span>HasFastDoubleElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3805">lineno 3805</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFastHoleyElements"><span class="type-signature"></span>HasFastHoleyElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3819">lineno 3819</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFastObjectElements"><span class="type-signature"></span>HasFastObjectElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3791">lineno 3791</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFastProperties"><span class="type-signature"></span>HasFastProperties<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4127">lineno 4127</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFastSmiElements"><span class="type-signature"></span>HasFastSmiElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3763">lineno 3763</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFastSmiOrObjectElements"><span class="type-signature"></span>HasFastSmiOrObjectElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3777">lineno 3777</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedFloat32Elements"><span class="type-signature"></span>HasFixedFloat32Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4099">lineno 4099</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedFloat64Elements"><span class="type-signature"></span>HasFixedFloat64Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4113">lineno 4113</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedInt8Elements"><span class="type-signature"></span>HasFixedInt8Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4015">lineno 4015</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedInt16Elements"><span class="type-signature"></span>HasFixedInt16Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4043">lineno 4043</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedInt32Elements"><span class="type-signature"></span>HasFixedInt32Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4071">lineno 4071</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedUint8ClampedElements"><span class="type-signature"></span>HasFixedUint8ClampedElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4001">lineno 4001</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedUint8Elements"><span class="type-signature"></span>HasFixedUint8Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4029">lineno 4029</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedUint16Elements"><span class="type-signature"></span>HasFixedUint16Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4057">lineno 4057</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasFixedUint32Elements"><span class="type-signature"></span>HasFixedUint32Elements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4085">lineno 4085</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasLocalProperty"><span class="type-signature"></span>HasLocalProperty<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L60">lineno 60</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasProperty"><span class="type-signature"></span>HasProperty<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L75">lineno 75</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HasSloppyArgumentsElements"><span class="type-signature"></span>HasSloppyArgumentsElements<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3847">lineno 3847</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="HaveSameMap"><span class="type-signature"></span>HaveSameMap<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4156">lineno 4156</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IS_VAR"><span class="type-signature"></span>IS_VAR<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3749">lineno 3749</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsAttachedGlobal"><span class="type-signature"></span>IsAttachedGlobal<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2280">lineno 2280</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsBreakOnException"><span class="type-signature"></span>IsBreakOnException<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4619">lineno 4619</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsConcurrentRecompilationSupported"><span class="type-signature"></span>IsConcurrentRecompilationSupported<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L504">lineno 504</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsExtensible"><span class="type-signature"></span>IsExtensible<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L363">lineno 363</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsInPrototypeChain"><span class="type-signature"></span>IsInPrototypeChain<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L333">lineno 333</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsJSFunctionProxy"><span class="type-signature"></span>IsJSFunctionProxy<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2619">lineno 2619</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsJSGlobalProxy"><span class="type-signature"></span>IsJSGlobalProxy<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4171">lineno 4171</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsJSModule"><span class="type-signature"></span>IsJSModule<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2462">lineno 2462</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsJSProxy"><span class="type-signature"></span>IsJSProxy<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2605">lineno 2605</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsMinusZero"><span class="type-signature"></span>IsMinusZero<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5352">lineno 5352</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsObserved"><span class="type-signature"></span>IsObserved<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3067">lineno 3067</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsPropertyEnumerable"><span class="type-signature"></span>IsPropertyEnumerable<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L105">lineno 105</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsSloppyModeFunction"><span class="type-signature"></span>IsSloppyModeFunction<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L276">lineno 276</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsTemplate"><span class="type-signature"></span>IsTemplate<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2074">lineno 2074</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="IsValidSmi"><span class="type-signature"></span>IsValidSmi<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1697">lineno 1697</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="KeyedGetProperty"><span class="type-signature"></span>KeyedGetProperty<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L29">lineno 29</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditCheckAndDropActivations"><span class="type-signature"></span>LiveEditCheckAndDropActivations<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4948">lineno 4948</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditCompareStrings"><span class="type-signature"></span>LiveEditCompareStrings<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4963">lineno 4963</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditFindSharedFunctionInfosForScript"><span class="type-signature"></span>LiveEditFindSharedFunctionInfosForScript<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4828">lineno 4828</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditFunctionSetScript"><span class="type-signature"></span>LiveEditFunctionSetScript<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4902">lineno 4902</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditFunctionSourceUpdated"><span class="type-signature"></span>LiveEditFunctionSourceUpdated<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4888">lineno 4888</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditGatherCompileInfo"><span class="type-signature"></span>LiveEditGatherCompileInfo<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4842">lineno 4842</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditPatchFunctionPositions"><span class="type-signature"></span>LiveEditPatchFunctionPositions<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4933">lineno 4933</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditReplaceFunctionCode"><span class="type-signature"></span>LiveEditReplaceFunctionCode<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4873">lineno 4873</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditReplaceRefToNestedFunction"><span class="type-signature"></span>LiveEditReplaceRefToNestedFunction<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4917">lineno 4917</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditReplaceScript"><span class="type-signature"></span>LiveEditReplaceScript<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4857">lineno 4857</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LiveEditRestartFrame"><span class="type-signature"></span>LiveEditRestartFrame<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4978">lineno 4978</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LoadMutableDouble"><span class="type-signature"></span>LoadMutableDouble<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L673">lineno 673</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LocalKeys"><span class="type-signature"></span>LocalKeys<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3707">lineno 3707</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="LookupAccessor"><span class="type-signature"></span>LookupAccessor<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2419">lineno 2419</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapClear"><span class="type-signature"></span>MapClear<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2878">lineno 2878</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapCreateIterator"><span class="type-signature"></span>MapCreateIterator<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2922">lineno 2922</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapDelete"><span class="type-signature"></span>MapDelete<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2863">lineno 2863</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapGet"><span class="type-signature"></span>MapGet<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2833">lineno 2833</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapGetSize"><span class="type-signature"></span>MapGetSize<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2908">lineno 2908</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapHas"><span class="type-signature"></span>MapHas<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2848">lineno 2848</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapInitialize"><span class="type-signature"></span>MapInitialize<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2819">lineno 2819</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapIteratorClose"><span class="type-signature"></span>MapIteratorClose<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2951">lineno 2951</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapIteratorNext"><span class="type-signature"></span>MapIteratorNext<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2937">lineno 2937</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MapSet"><span class="type-signature"></span>MapSet<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2892">lineno 2892</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathAcos"><span class="type-signature"></span>MathAcos<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1260">lineno 1260</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathAsin"><span class="type-signature"></span>MathAsin<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1274">lineno 1274</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathAtan"><span class="type-signature"></span>MathAtan<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1288">lineno 1288</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathAtan2"><span class="type-signature"></span>MathAtan2<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1316">lineno 1316</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathExp"><span class="type-signature"></span>MathExp<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1331">lineno 1331</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathFloor"><span class="type-signature"></span>MathFloor<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1302">lineno 1302</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathFround"><span class="type-signature"></span>MathFround<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1359">lineno 1359</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathLog"><span class="type-signature"></span>MathLog<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5763">lineno 5763</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MathSqrt"><span class="type-signature"></span>MathSqrt<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5749">lineno 5749</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MaxSmi"><span class="type-signature"></span>MaxSmi<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5624">lineno 5624</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MessageGetScript"><span class="type-signature"></span>MessageGetScript<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3735">lineno 3735</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MessageGetStartPosition"><span class="type-signature"></span>MessageGetStartPosition<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3721">lineno 3721</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="MoveArrayContents"><span class="type-signature"></span>MoveArrayContents<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2390">lineno 2390</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NeverOptimizeFunction"><span class="type-signature"></span>NeverOptimizeFunction<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L517">lineno 517</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NewObjectFromBound"><span class="type-signature"></span>NewObjectFromBound<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3581">lineno 3581</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NewString"><span class="type-signature"></span>NewString<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1607">lineno 1607</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NewStringWrapper"><span class="type-signature"></span>NewStringWrapper<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1593">lineno 1593</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NewSymbolWrapper"><span class="type-signature"></span>NewSymbolWrapper<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2518">lineno 2518</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NotifyContextDisposed"><span class="type-signature"></span>NotifyContextDisposed<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L702">lineno 702</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberAdd"><span class="type-signature"></span>NumberAdd<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L957">lineno 957</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberAnd"><span class="type-signature"></span>NumberAnd<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1124">lineno 1124</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberCompare"><span class="type-signature"></span>NumberCompare<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1229">lineno 1229</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberDiv"><span class="type-signature"></span>NumberDiv<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1002">lineno 1002</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberEquals"><span class="type-signature"></span>NumberEquals<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1199">lineno 1199</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberImul"><span class="type-signature"></span>NumberImul<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1046">lineno 1046</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberMod"><span class="type-signature"></span>NumberMod<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1017">lineno 1017</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberMul"><span class="type-signature"></span>NumberMul<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L987">lineno 987</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberOr"><span class="type-signature"></span>NumberOr<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1109">lineno 1109</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberSar"><span class="type-signature"></span>NumberSar<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1184">lineno 1184</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberShl"><span class="type-signature"></span>NumberShl<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1154">lineno 1154</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberShr"><span class="type-signature"></span>NumberShr<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1169">lineno 1169</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberSub"><span class="type-signature"></span>NumberSub<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L972">lineno 972</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToExponential"><span class="type-signature"></span>NumberToExponential<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1667">lineno 1667</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToFixed"><span class="type-signature"></span>NumberToFixed<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1652">lineno 1652</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToInteger"><span class="type-signature"></span>NumberToInteger<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L901">lineno 901</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToIntegerMapMinusZero"><span class="type-signature"></span>NumberToIntegerMapMinusZero<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L915">lineno 915</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToJSInt32"><span class="type-signature"></span>NumberToJSInt32<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L943">lineno 943</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToJSUint32"><span class="type-signature"></span>NumberToJSUint32<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L929">lineno 929</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToPrecision"><span class="type-signature"></span>NumberToPrecision<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1682">lineno 1682</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberToRadixString"><span class="type-signature"></span>NumberToRadixString<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1637">lineno 1637</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberUnaryMinus"><span class="type-signature"></span>NumberUnaryMinus<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1032">lineno 1032</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="NumberXor"><span class="type-signature"></span>NumberXor<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1139">lineno 1139</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ObjectFreeze"><span class="type-signature"></span>ObjectFreeze<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2435">lineno 2435</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ObjectGetNotifierInObjectContext"><span class="type-signature"></span>ObjectGetNotifierInObjectContext<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3167">lineno 3167</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ObjectNotifierPerformChangeInObjectContext"><span class="type-signature"></span>ObjectNotifierPerformChangeInObjectContext<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3181">lineno 3181</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ObjectObserveInObjectContext"><span class="type-signature"></span>ObjectObserveInObjectContext<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3151">lineno 3151</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ObjectWasCreatedInCurrentOrigin"><span class="type-signature"></span>ObjectWasCreatedInCurrentOrigin<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3137">lineno 3137</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ObservationWeakMapCreate"><span class="type-signature"></span>ObservationWeakMapCreate<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3108">lineno 3108</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ObserverObjectAndRecordHaveSameOrigin"><span class="type-signature"></span>ObserverObjectAndRecordHaveSameOrigin<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3121">lineno 3121</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="OneByteSeqStringSetChar"><span class="type-signature"></span>OneByteSeqStringSetChar<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5220">lineno 5220</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="OptimizeObjectForAddingMultipleProperties"><span class="type-signature"></span>OptimizeObjectForAddingMultipleProperties<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3595">lineno 3595</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ParseJson"><span class="type-signature"></span>ParseJson<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1424">lineno 1424</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="PrepareStep"><span class="type-signature"></span>PrepareStep<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented
BREAKS due to immediate execution</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4633">lineno 4633</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="PreventExtensions"><span class="type-signature"></span>PreventExtensions<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L377">lineno 377</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="PushIfAbsent"><span class="type-signature"></span>PushIfAbsent<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L715">lineno 715</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="QuoteJSONString"><span class="type-signature"></span>QuoteJSONString<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1452">lineno 1452</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="RegExpCompile"><span class="type-signature"></span>RegExpCompile<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1373">lineno 1373</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="RegExpExecMultiple"><span class="type-signature"></span>RegExpExecMultiple<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1389">lineno 1389</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="RegExpInitializeObject"><span class="type-signature"></span>RegExpInitializeObject<span class="signature">(arg1, arg2, arg3, arg4, arg5)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1406">lineno 1406</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="RemoveArrayHoles"><span class="type-signature"></span>RemoveArrayHoles<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2360">lineno 2360</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="RoundNumber"><span class="type-signature"></span>RoundNumber<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1345">lineno 1345</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="RunMicrotasks"><span class="type-signature"></span>RunMicrotasks<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3054">lineno 3054</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="RunningInSimulator"><span class="type-signature"></span>RunningInSimulator<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L491">lineno 491</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetAccessorProperty"><span class="type-signature"></span>SetAccessorProperty<span class="signature">(arg1, arg2, arg3, arg4, arg5, arg6)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg6</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2131">lineno 2131</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetAdd"><span class="type-signature"></span>SetAdd<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2703">lineno 2703</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetClear"><span class="type-signature"></span>SetClear<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2748">lineno 2748</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetCode"><span class="type-signature"></span>SetCode<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2028">lineno 2028</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetCreateIterator"><span class="type-signature"></span>SetCreateIterator<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2776">lineno 2776</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetDebugEventListener"><span class="type-signature"></span>SetDebugEventListener<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4199">lineno 4199</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetDelete"><span class="type-signature"></span>SetDelete<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2733">lineno 2733</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetDisableBreak"><span class="type-signature"></span>SetDisableBreak<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4526">lineno 4526</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetExpectedNumberOfProperties"><span class="type-signature"></span>SetExpectedNumberOfProperties<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2043">lineno 2043</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetFlags"><span class="type-signature"></span>SetFlags<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5023">lineno 5023</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetFunctionBreakPoint"><span class="type-signature"></span>SetFunctionBreakPoint<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4556">lineno 4556</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetGetSize"><span class="type-signature"></span>SetGetSize<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2762">lineno 2762</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetHas"><span class="type-signature"></span>SetHas<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2718">lineno 2718</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetHiddenProperty"><span class="type-signature"></span>SetHiddenProperty<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2344">lineno 2344</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetInitialize"><span class="type-signature"></span>SetInitialize<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2689">lineno 2689</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetInlineBuiltinFlag"><span class="type-signature"></span>SetInlineBuiltinFlag<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L586">lineno 586</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetIsObserved"><span class="type-signature"></span>SetIsObserved<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3081">lineno 3081</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetIteratorClose"><span class="type-signature"></span>SetIteratorClose<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2805">lineno 2805</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetIteratorNext"><span class="type-signature"></span>SetIteratorNext<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2791">lineno 2791</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetMicrotaskPending"><span class="type-signature"></span>SetMicrotaskPending<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3040">lineno 3040</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetNativeFlag"><span class="type-signature"></span>SetNativeFlag<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L572">lineno 572</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetPrototype"><span class="type-signature"></span>SetPrototype<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L318">lineno 318</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetScopeVariableValue"><span class="type-signature"></span>SetScopeVariableValue<span class="signature">(arg1, arg2, arg3, arg4, arg5, arg6)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg6</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4465">lineno 4465</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SetScriptBreakPoint"><span class="type-signature"></span>SetScriptBreakPoint<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented
BREAKS due to immediate execution</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4572">lineno 4572</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SmiLexicographicCompare"><span class="type-signature"></span>SmiLexicographicCompare<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1245">lineno 1245</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SparseJoinWithSeparator"><span class="type-signature"></span>SparseJoinWithSeparator<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1093">lineno 1093</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SpecialArrayFunctions"><span class="type-signature"></span>SpecialArrayFunctions<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L262">lineno 262</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StoreArrayLiteralElement"><span class="type-signature"></span>StoreArrayLiteralElement<span class="signature">(arg1, arg2, arg3, arg4, arg5)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L600">lineno 600</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringBuilderConcat"><span class="type-signature"></span>StringBuilderConcat<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1061">lineno 1061</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringBuilderJoin"><span class="type-signature"></span>StringBuilderJoin<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1077">lineno 1077</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringEquals"><span class="type-signature"></span>StringEquals<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1214">lineno 1214</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringIndexOf"><span class="type-signature"></span>StringIndexOf<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1466">lineno 1466</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringLastIndexOf"><span class="type-signature"></span>StringLastIndexOf<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1482">lineno 1482</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringLocaleCompare"><span class="type-signature"></span>StringLocaleCompare<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1498">lineno 1498</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringMatch"><span class="type-signature"></span>StringMatch<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1546">lineno 1546</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringParseFloat"><span class="type-signature"></span>StringParseFloat<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L801">lineno 801</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringParseInt"><span class="type-signature"></span>StringParseInt<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L786">lineno 786</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringReplaceGlobalRegExpWithString"><span class="type-signature"></span>StringReplaceGlobalRegExpWithString<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1513">lineno 1513</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringReplaceOneCharWithString"><span class="type-signature"></span>StringReplaceOneCharWithString<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1530">lineno 1530</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringSplit"><span class="type-signature"></span>StringSplit<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L843">lineno 843</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringToArray"><span class="type-signature"></span>StringToArray<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1578">lineno 1578</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringToLowerCase"><span class="type-signature"></span>StringToLowerCase<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L815">lineno 815</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringToNumber"><span class="type-signature"></span>StringToNumber<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L772">lineno 772</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringToUpperCase"><span class="type-signature"></span>StringToUpperCase<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L829">lineno 829</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="StringTrim"><span class="type-signature"></span>StringTrim<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1562">lineno 1562</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SymbolDescription"><span class="type-signature"></span>SymbolDescription<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2532">lineno 2532</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SymbolIsPrivate"><span class="type-signature"></span>SymbolIsPrivate<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2559">lineno 2559</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SymbolRegistry"><span class="type-signature"></span>SymbolRegistry<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2546">lineno 2546</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="SystemBreak"><span class="type-signature"></span>SystemBreak<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4773">lineno 4773</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ToBool"><span class="type-signature"></span>ToBool<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L744">lineno 744</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="ToFastProperties"><span class="type-signature"></span>ToFastProperties<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L234">lineno 234</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TraceEnter"><span class="type-signature"></span>TraceEnter<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3651">lineno 3651</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TraceExit"><span class="type-signature"></span>TraceExit<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3664">lineno 3664</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TransitionElementsKind"><span class="type-signature"></span>TransitionElementsKind<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L4141">lineno 4141</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TruncateString"><span class="type-signature"></span>TruncateString<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L1622">lineno 1622</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TryMigrateInstance"><span class="type-signature"></span>TryMigrateInstance<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L688">lineno 688</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TwoByteSeqStringSetChar"><span class="type-signature"></span>TwoByteSeqStringSetChar<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5236">lineno 5236</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TypedArrayGetBuffer"><span class="type-signature"></span>TypedArrayGetBuffer<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3273">lineno 3273</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TypedArrayGetLength"><span class="type-signature"></span>TypedArrayGetLength<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5678">lineno 5678</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TypedArrayInitialize"><span class="type-signature"></span>TypedArrayInitialize<span class="signature">(arg1, arg2, arg3, arg4, arg5)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg5</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5589">lineno 5589</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TypedArrayInitializeFromArrayLike"><span class="type-signature"></span>TypedArrayInitializeFromArrayLike<span class="signature">(arg1, arg2, arg3, arg4)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg4</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3256">lineno 3256</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TypedArrayMaxSizeInHeap"><span class="type-signature"></span>TypedArrayMaxSizeInHeap<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L5637">lineno 5637</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="TypedArraySetFastCases"><span class="type-signature"></span>TypedArraySetFastCases<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3287">lineno 3287</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="Typeof"><span class="type-signature"></span>Typeof<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L758">lineno 758</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="UnblockConcurrentRecompilation"><span class="type-signature"></span>UnblockConcurrentRecompilation<span class="signature">()</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L545">lineno 545</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="URIEscape"><span class="type-signature"></span>URIEscape<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L873">lineno 873</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="URIUnescape"><span class="type-signature"></span>URIUnescape<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L887">lineno 887</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="WeakCollectionDelete"><span class="type-signature"></span>WeakCollectionDelete<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3009">lineno 3009</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="WeakCollectionGet"><span class="type-signature"></span>WeakCollectionGet<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2979">lineno 2979</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="WeakCollectionHas"><span class="type-signature"></span>WeakCollectionHas<span class="signature">(arg1, arg2)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2994">lineno 2994</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="WeakCollectionInitialize"><span class="type-signature"></span>WeakCollectionInitialize<span class="signature">(arg1)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L2965">lineno 2965</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
<dt>
<h4 class="name" id="WeakCollectionSet"><span class="type-signature"></span>WeakCollectionSet<span class="signature">(arg1, arg2, arg3)</span><span class="type-signature"></span></h4>
</dt>
<dd>
<div class="description">
<p>Undocumented</p>
</div>
<h5>Parameters:</h5>
<table class="params">
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th class="last">Description</th>
</tr>
</thead>
<tbody>
<tr>
<td class="name"><code>arg1</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg2</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
<tr>
<td class="name"><code>arg3</code></td>
<td class="type">
</td>
<td class="description last"></td>
</tr>
</tbody>
</table>
<dl class="details">
<dt class="tag-source">Source:</dt>
<dd class="tag-source"><ul class="dummy">
<li>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js">index.js</a>
<span>, </span>
<a href="https://github.com/thlorenz/v8-runtime-functions/blob/master/index.js#L3024">lineno 3024</a>
</li>
</ul></dd>
</dl>
<h5>Returns:</h5>
</dd>
</dl>
</article>
</section>
</div>

*generated with [docme](https://github.com/thlorenz/docme)*
</div>
<!-- END docme generated API please keep comment here to allow auto update -->

## License

MIT
